#!/usr/local/bin/perl -- -*-perl-*-
#
# exchange.pl
#
# This is a very simple perl script to redirect the standard output of a
# Progress session to a browser.
# I would not reccomend building your web interface with this script!
#

# Default Contect Type is text/html.
$XMLContent = 0;

# Use the CGI perl module
use CGI;
$q = new CGI;

#
# Parse and then export any arguments into environment variables
#
%params = $q->Vars;
foreach $key (sort keys(%params)) {
    # Copy associated value to $var
    $var = $params{$key};
    # Convert null's delimiting multi-selected values to commas.
    $var =~ tr/\0/,/;
    # Export to environment
    $ENV{"$key"} = $var;
    # Pull out the program name, and the xml content indicator
    if ("$key" eq 'prog') {$Program = $var};
    if ("$key" eq 'sendxml') {$SendXML = $var};
};

# Check for xml content
if ($SendXML =~ /[1yt]/i) { $XMLContent = 1; }

# Set Progress environment variables
$DLC = "/usr/dlc";
$ENV{'DLC'} = $DLC;
$ENV{'PROPATH'} .= "/home/cmorgan/innov-2:$DLC";

# Adjust $PATH to include DLC for Progress's benefit
$PATH = $ENV{'PATH'} . ":/usr/local/bin:" . $DLC . "/bin";
$ENV{'PATH'} = $PATH;

# Set a default terminal type so Progress doesn't complain
$ENV{'TERM'} = "ansi" unless -t STDIN;


#
#  Note that it is important to send the proper contect type when
#  sending xml responses.
#
if ($XMLContent == 0) {
    print $q->header('text/html');
}
else {
    print $q->header('text/xml');
}

# run the Progress program
system( "${DLC}/bin/_progres -b -pf /home/cmorgan/innov-2/sports.pf " .
        "-p $Program");

exit 0;

